KPassivePopup Class Reference

`#include <kpassivepopup.h>`

Inherits QFrame.

## Public Types

enum | PopupStyle { Boxed, Balloon, CustomStyle =128 }

## Public Slots

void | setTimeout (int delay)
virtual void | show ()
void | show (const QPoint &p)

## Signals

void | clicked ()
void | clicked (QPoint pos)

## Public Member Functions

| KPassivePopup (QWidget *parent=0, const char *name=0, WFlags f=0)
| KPassivePopup (WId parent, const char *name=0, WFlags f=0)
| KPassivePopup (int popupStyle, QWidget *parent=0, const char *name=0, WFlags f=0)
| KPassivePopup (int popupStyle, WId parent, const char *name=0, WFlags f=0)
virtual | ~KPassivePopup ()
void | setView (QWidget *child)
void | setView (const QString &caption, const QString &text=QString::null)
virtual void | setView (const QString &caption, const QString &text, const QPixmap &icon)
QVBox * | standardView (const QString &caption, const QString &text, const QPixmap &icon, QWidget *parent=0L)
QWidget * | view () const
int | timeout () const
virtual void | setAutoDelete (bool autoDelete)
bool | autoDelete () const
void | setAnchor (const QPoint &anchor)

## Static Public Member Functions

static KPassivePopup * | message (const QString &text, QWidget *parent, const char *name=0)
static KPassivePopup * | message (const QString &caption, const QString &text, QWidget *parent, const char *name=0)
static KPassivePopup * | message (const QString &caption, const QString &text, const QPixmap &icon, QWidget *parent, const char *name=0, int timeout=-1)
static KPassivePopup * | message (const QString &caption, const QString &text, const QPixmap &icon, WId parent, const char *name=0, int timeout=-1)
static KPassivePopup * | message (int popupStyle, const QString &text, QWidget *parent, const char *name=0)
static KPassivePopup * | message (int popupStyle, const QString &caption, const QString &text, QWidget *parent, const char *name=0)
static KPassivePopup * | message (int popupStyle, const QString &caption, const QString &text, const QPixmap &icon, QWidget *parent, const char *name=0, int timeout=-1)
static KPassivePopup * | message (int popupStyle, const QString &caption, const QString &text, const QPixmap &icon, WId parent, const char *name=0, int timeout=-1)

## Protected Member Functions

virtual void | positionSelf ()
virtual void | hideEvent (QHideEvent *)
void | moveNear (QRect target)
virtual void | mouseReleaseEvent (QMouseEvent *e)
QRect | defaultArea () const
void | updateMask ()
virtual void | paintEvent (QPaintEvent *pe)

## Properties

bool | autoDelete
int | timeout

## Detailed Description

A dialog-like popup that displays messages without interupting the user.

The simplest uses of KPassivePopup are by using the various message() static methods. The position the popup appears at depends on the type of the parent window:

- Normal Windows: The popup is placed adjacent to the icon of the window.
- System Tray Windows: The popup is placed adjact to the system tray window itself.
- Skip Taskbar Windows: The popup is placed adjact to the window itself if it is visible, and at the edge of the desktop otherwise.

You also have the option of calling show with a QPoint as a parameter that removes the automatic placing of KPassivePopup and shows it in the point you want.

The most basic use of KPassivePopup displays a popup containing a piece of text:

KPassivePopup::message( "This is the message", this );

We can create popups with titles and icons too, as this example shows:

QPixmap px;
px.load( "hi32-app-logtracker.png" );
KPassivePopup::message( "Some title", "This is the main text", px, this );

For more control over the popup, you can use the setView(QWidget *) method to create a custom popup.

KPassivePopup *pop = new KPassivePopup( parent );
QVBox *vb = new QVBox( pop );
(void) new QLabel( vb, "<b>Isn't this great?</b>" );
QHBox *box = new QHBox( vb );
(void) new QPushButton( box, "Yes" );
(void) new QPushButton( box, "No" );
pop->setView( vb );
pop->show();

Version

Id
  kpassivepopup.h 428049 2005-06-22 21:24:17Z aacid

Since
  3.1

Author
  Richard Moore, rich@.nosp@m.kde..nosp@m.org
  Sascha Cunz, sasch.nosp@m.a.cu.nosp@m.nz@ti.nosp@m.scal.nosp@m.i.de

Definition at line 68 of file kpassivepopup.h.

## Member Enumeration Documentation

enum KPassivePopup::PopupStyle

Styles that a KPassivePopup can have.

Since
  3.5

Enumerator
Boxed | Information will appear in a framed box (default)
Balloon | Information will appear in a comic-alike balloon.
CustomStyle | Ids greater than this are reserved for use by subclasses.

Definition at line 79 of file kpassivepopup.h.

## Constructor & Destructor Documentation

KPassivePopup::KPassivePopup | ( | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | WFlags | f = `0`
| ) |  |

Creates a popup for the specified widget.

Definition at line 49 of file kpassivepopup.cpp.

KPassivePopup::KPassivePopup | ( | WId | parent,
|  | const char * | name = `0`,
|  | WFlags | f = `0`
| ) |  |

Creates a popup for the specified window.

Definition at line 58 of file kpassivepopup.cpp.

KPassivePopup::KPassivePopup | ( | int | popupStyle,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | WFlags | f = `0`
| ) |  |

Creates a popup for the specified widget.

Since
  3.5

Definition at line 67 of file kpassivepopup.cpp.

KPassivePopup::KPassivePopup | ( | int | popupStyle,
|  | WId | parent,
|  | const char * | name = `0`,
|  | WFlags | f = `0`
| ) |  |

Creates a popup for the specified window.

Since
  3.5

Definition at line 76 of file kpassivepopup.cpp.

KPassivePopup::~KPassivePopup | ( |  | ) |

virtual

Cleans up.

Definition at line 103 of file kpassivepopup.cpp.

## Member Function Documentation

bool KPassivePopup::autoDelete | ( |  | ) | const

inline

Returns
  true if the widget auto-deletes itself when the timeout occurs.

See also
  setAutoDelete

Definition at line 173 of file kpassivepopup.h.

void KPassivePopup::clicked | ( |  | ) |

signal

Emitted when the popup is clicked.

void KPassivePopup::clicked | ( | QPoint | pos | ) |

signal

Emitted when the popup is clicked.

QRect KPassivePopup::defaultArea | ( |  | ) | const

protected

If no relative window (eg taskbar button, system tray window) is available, use this rectangle (pass it to moveNear()).

Basically KWinModule::workArea() with width and height set to 0 so that moveNear uses the upper-left position.

Returns
  The QRect to be passed to moveNear() if no other is available.

Definition at line 233 of file kpassivepopup.cpp.

void KPassivePopup::hideEvent | ( | QHideEvent * |  | ) |

protected virtual

Reimplemented to destroy the object when autoDelete() is enabled.

Definition at line 226 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | const QString & | text,
|  | QWidget * | parent,
|  | const char * | name = `0`
| ) |  |

static

Convenience method that displays popup with the specified message beside the icon of the specified widget.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 443 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | const QString & | caption,
|  | const QString & | text,
|  | QWidget * | parent,
|  | const char * | name = `0`
| ) |  |

static

Convenience method that displays popup with the specified caption and message beside the icon of the specified widget.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 448 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | const QString & | caption,
|  | const QString & | text,
|  | const QPixmap & | icon,
|  | QWidget * | parent,
|  | const char * | name = `0`,
|  | int | timeout = `-1`
| ) |  |

static

Convenience method that displays popup with the specified icon, caption and message beside the icon of the specified widget.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 436 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | const QString & | caption,
|  | const QString & | text,
|  | const QPixmap & | icon,
|  | WId | parent,
|  | const char * | name = `0`,
|  | int | timeout = `-1`
| ) |  |

static

Convenience method that displays popup with the specified icon, caption and message beside the icon of the specified window.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 454 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | int | popupStyle,
|  | const QString & | text,
|  | QWidget * | parent,
|  | const char * | name = `0`
| ) |  |

static

Convenience method that displays popup with the specified popup-style and message beside the icon of the specified widget.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 473 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | int | popupStyle,
|  | const QString & | caption,
|  | const QString & | text,
|  | QWidget * | parent,
|  | const char * | name = `0`
| ) |  |

static

Convenience method that displays popup with the specified popup-style, caption and message beside the icon of the specified widget.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 478 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | int | popupStyle,
|  | const QString & | caption,
|  | const QString & | text,
|  | const QPixmap & | icon,
|  | QWidget * | parent,
|  | const char * | name = `0`,
|  | int | timeout = `-1`
| ) |  |

static

Convenience method that displays popup with the specified popup-style, icon, caption and message beside the icon of the specified widget.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 460 of file kpassivepopup.cpp.

KPassivePopup * KPassivePopup::message | ( | int | popupStyle,
|  | const QString & | caption,
|  | const QString & | text,
|  | const QPixmap & | icon,
|  | WId | parent,
|  | const char * | name = `0`,
|  | int | timeout = `-1`
| ) |  |

static

Convenience method that displays popup with the specified popup-style, icon, caption and message beside the icon of the specified window.

Note that the returned object is destroyed when it is hidden.

See also
  setAutoDelete

Definition at line 484 of file kpassivepopup.cpp.

void KPassivePopup::mouseReleaseEvent | ( | QMouseEvent * | e | ) |

protected virtual

Reimplemented to detect mouse clicks.

Definition at line 185 of file kpassivepopup.cpp.

void KPassivePopup::moveNear | ( | QRect | target | ) |

protected

Moves the popup to be adjacent to the icon of the specified rectangle.

Definition at line 294 of file kpassivepopup.cpp.

void KPassivePopup::paintEvent | ( | QPaintEvent * | pe | ) |

protected virtual

Overwrite to paint the border when PopupStyle == Balloon.

Unused if PopupStyle == Boxed

Definition at line 346 of file kpassivepopup.cpp.

void KPassivePopup::positionSelf | ( |  | ) |

protected virtual

This method positions the popup.

Definition at line 253 of file kpassivepopup.cpp.

void KPassivePopup::setAnchor | ( | const QPoint & | anchor | ) |

Sets the anchor of this balloon.

The balloon tries automatically to adjust itself somehow around the point.

Since
  3.5

Definition at line 340 of file kpassivepopup.cpp.

void KPassivePopup::setAutoDelete | ( | bool | autoDelete | ) |

virtual

Enables / disables auto-deletion of this widget when the timeout occurs.

The default is false. If you use the class-methods message(), auto-delection is turned on by default.

Definition at line 180 of file kpassivepopup.cpp.

void KPassivePopup::setTimeout | ( | int | delay | ) |

slot

Sets the delay for the popup is removed automatically.

Setting the delay to 0 disables the timeout, if you're doing this, you may want to connect the clicked() signal to the hide() slot. Setting the delay to -1 makes it use the default value.

See also
  timeout

Definition at line 167 of file kpassivepopup.cpp.

void KPassivePopup::setView | ( | QWidget * | child | ) |

Sets the main view to be the specified widget (which must be a child of the popup).

Definition at line 108 of file kpassivepopup.cpp.

void KPassivePopup::setView | ( | const QString & | caption,
|  | const QString & | text = `QString::null`
| ) |  |

Creates a standard view then calls setView(QWidget*) .

Definition at line 162 of file kpassivepopup.cpp.

void KPassivePopup::setView | ( | const QString & | caption,
|  | const QString & | text,
|  | const QPixmap & | icon
| ) |  |

virtual

Creates a standard view then calls setView(QWidget*) .

Definition at line 119 of file kpassivepopup.cpp.

void KPassivePopup::show | ( | void |  | ) |

virtual slot

Reimplemented to reposition the popup.

Definition at line 195 of file kpassivepopup.cpp.

void KPassivePopup::show | ( | const QPoint & | p | ) |

slot

Shows the popup in the given point.

Since
  3.5

Definition at line 220 of file kpassivepopup.cpp.

QVBox * KPassivePopup::standardView | ( | const QString & | caption,
|  | const QString & | text,
|  | const QPixmap & | icon,
|  | QWidget * | parent = `0L`
| ) |  |

Returns a widget that is used as standard view if one of the setView() methods taking the QString arguments is used.

You can use the returned widget to customize the passivepopup while keeping the look similar to the "standard" passivepopups.

After customizing the widget, pass it to setView( QWidget* )

Parameters

  caption | The window caption (title) on the popup
  text | The text for the popup
  icon | The icon to use for the popup
  parent | The parent widget used for the returned QVBox. If left 0L, then "this", i.e. the passive popup object will be used.

Returns
  a QVBox containing the given arguments, looking like the standard passivepopups.

See also
  setView( QWidget * )
  setView( const QString&, const QString& )
  setView( const QString&, const QString&, const QPixmap& )

Definition at line 126 of file kpassivepopup.cpp.

int KPassivePopup::timeout | ( |  | ) | const

inline

Returns the delay before the popup is removed automatically.

Definition at line 159 of file kpassivepopup.h.

void KPassivePopup::updateMask | ( |  | ) |

protected

Updates the transparency mask.

Unused if PopupStyle == Boxed

Since
  3.5

Definition at line 357 of file kpassivepopup.cpp.

QWidget* KPassivePopup::view | ( |  | ) | const

inline

Returns the main view.

Definition at line 154 of file kpassivepopup.h.

The documentation for this class was generated from the following files:

- kpassivepopup.h
- kpassivepopup.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys